<?php 
/*
 * The ps_session class for PHP4
 *
 * Copyright (c) Edikon Corporation.  All rights reserved.
 * Distributed under the phpShop Public License (pSPL) Version 1.0.
 *
 * $Id: ps_session_4.inc,v 1.5 2000/09/13 16:34:38 pfmartin Exp $
 *
 */



class ps_session {
  var $classname = "ps_session";
  var $table_name = "sessions";
  var $serial_spacer = "|";
  var $firstcall;
  
  // Public
  function ps_session($newname = "ps_session", $forcenew=0) {
    session_start();
  }
  
  
  // Public
  // Reference a global variable into the session
  function register($var) {
    session_register("$var");
  }

  // Public
  // unreference a global variable from the session
  function unregister($var) {
    session_unregister($var);
  }

  // Public
  // clear the session
  function destroy() {
    session_destroy();
  }
  
  // Public
  // save all registered variables.  Should be called at end of page
  function save() {
    return True;
  }
  
  
  // Need these for backwards phplib compatibility
  function url($text) {
    global $QUERY_STRING;
    global $HTTP_COOKIE_VARS;
    global $HTTP_GET_VARS;
    global $HTTP_POST_VARS;

    if (empty($HTTP_COOKIE_VARS[$this->name])) {
      // Check for argument delimiter
      if (strpos($text, "?")) {
         $delim = "&";
      } 
      else {
         $delim = "?";
      }
      return $text . $delim . SID;
    }
    else 
      return $text;
  }

  function purl($text) {
    global $QUERY_STRING;   
    global $HTTP_GET_VARS;
    global $HTTP_POST_VARS;

    global $HTTP_COOKIE_VARS;

    if (empty($HTTP_COOKIE_VARS[$this->name])) {

    	// Check for argument delimiter
      if (strpos($text, "?")) {
       		$delim = "&";
    	} 
    	else {
       		$delim = "?";
    	}
    	echo $text . $delim . SID;
    	return 1;
     }
     else {
    	echo $text;
    	return 1;
     }

  }
  
  function hidden_session() {
    echo "<INPUT TYPE=HIDDEN NAME=" . session_name() . " VALUE=" . session_id() . ">";
  }

  function cleanup() {
    return True;
  }
  
} // end of class session
?>
